package domain

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// QueryBatchTaskList invokes the domain.QueryBatchTaskList API synchronously
func (client *Client) QueryBatchTaskList(request *QueryBatchTaskListRequest) (response *QueryBatchTaskListResponse, err error) {
	response = CreateQueryBatchTaskListResponse()
	err = client.DoAction(request, response)
	return
}

// QueryBatchTaskListWithChan invokes the domain.QueryBatchTaskList API asynchronously
func (client *Client) QueryBatchTaskListWithChan(request *QueryBatchTaskListRequest) (<-chan *QueryBatchTaskListResponse, <-chan error) {
	responseChan := make(chan *QueryBatchTaskListResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.QueryBatchTaskList(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// QueryBatchTaskListWithCallback invokes the domain.QueryBatchTaskList API asynchronously
func (client *Client) QueryBatchTaskListWithCallback(request *QueryBatchTaskListRequest, callback func(response *QueryBatchTaskListResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *QueryBatchTaskListResponse
		var err error
		defer close(result)
		response, err = client.QueryBatchTaskList(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// QueryBatchTaskListRequest is the request struct for api QueryBatchTaskList
type QueryBatchTaskListRequest struct {
	*requests.RpcRequest
	EndCreateTime   string           `position:"Query" name:"EndCreateTime"`
	PageNum         requests.Integer `position:"Query" name:"PageNum"`
	BeginCreateTime string           `position:"Query" name:"BeginCreateTime"`
	UserClientIp    string           `position:"Query" name:"UserClientIp"`
	PageSize        requests.Integer `position:"Query" name:"PageSize"`
	Lang            string           `position:"Query" name:"Lang"`
}

// QueryBatchTaskListResponse is the response struct for api QueryBatchTaskList
type QueryBatchTaskListResponse struct {
	*responses.BaseResponse
	PrePage        bool                     `json:"PrePage" xml:"PrePage"`
	CurrentPageNum int                      `json:"CurrentPageNum" xml:"CurrentPageNum"`
	RequestId      string                   `json:"RequestId" xml:"RequestId"`
	PageSize       int                      `json:"PageSize" xml:"PageSize"`
	TotalPageNum   int                      `json:"TotalPageNum" xml:"TotalPageNum"`
	TotalItemNum   int                      `json:"TotalItemNum" xml:"TotalItemNum"`
	NextPage       bool                     `json:"NextPage" xml:"NextPage"`
	Data           DataInQueryBatchTaskList `json:"Data" xml:"Data"`
}

// CreateQueryBatchTaskListRequest creates a request to invoke QueryBatchTaskList API
func CreateQueryBatchTaskListRequest() (request *QueryBatchTaskListRequest) {
	request = &QueryBatchTaskListRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("Domain", "2016-05-11", "QueryBatchTaskList", "domain", "openAPI")
	request.Method = requests.POST
	return
}

// CreateQueryBatchTaskListResponse creates a response to parse from QueryBatchTaskList response
func CreateQueryBatchTaskListResponse() (response *QueryBatchTaskListResponse) {
	response = &QueryBatchTaskListResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
