package domain

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// SaveContactTemplateCredential invokes the domain.SaveContactTemplateCredential API synchronously
func (client *Client) SaveContactTemplateCredential(request *SaveContactTemplateCredentialRequest) (response *SaveContactTemplateCredentialResponse, err error) {
	response = CreateSaveContactTemplateCredentialResponse()
	err = client.DoAction(request, response)
	return
}

// SaveContactTemplateCredentialWithChan invokes the domain.SaveContactTemplateCredential API asynchronously
func (client *Client) SaveContactTemplateCredentialWithChan(request *SaveContactTemplateCredentialRequest) (<-chan *SaveContactTemplateCredentialResponse, <-chan error) {
	responseChan := make(chan *SaveContactTemplateCredentialResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.SaveContactTemplateCredential(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// SaveContactTemplateCredentialWithCallback invokes the domain.SaveContactTemplateCredential API asynchronously
func (client *Client) SaveContactTemplateCredentialWithCallback(request *SaveContactTemplateCredentialRequest, callback func(response *SaveContactTemplateCredentialResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *SaveContactTemplateCredentialResponse
		var err error
		defer close(result)
		response, err = client.SaveContactTemplateCredential(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// SaveContactTemplateCredentialRequest is the request struct for api SaveContactTemplateCredential
type SaveContactTemplateCredentialRequest struct {
	*requests.RpcRequest
	CredentialNo      string           `position:"Query" name:"CredentialNo"`
	Credential        string           `position:"Query" name:"Credential"`
	UserClientIp      string           `position:"Query" name:"UserClientIp"`
	Lang              string           `position:"Query" name:"Lang"`
	ContactTemplateId requests.Integer `position:"Query" name:"ContactTemplateId"`
}

// SaveContactTemplateCredentialResponse is the response struct for api SaveContactTemplateCredential
type SaveContactTemplateCredentialResponse struct {
	*responses.BaseResponse
	RequestId string `json:"RequestId" xml:"RequestId"`
}

// CreateSaveContactTemplateCredentialRequest creates a request to invoke SaveContactTemplateCredential API
func CreateSaveContactTemplateCredentialRequest() (request *SaveContactTemplateCredentialRequest) {
	request = &SaveContactTemplateCredentialRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("Domain", "2016-05-11", "SaveContactTemplateCredential", "domain", "openAPI")
	request.Method = requests.POST
	return
}

// CreateSaveContactTemplateCredentialResponse creates a response to parse from SaveContactTemplateCredential response
func CreateSaveContactTemplateCredentialResponse() (response *SaveContactTemplateCredentialResponse) {
	response = &SaveContactTemplateCredentialResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
