package domain

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// SaveTaskForSubmittingDomainNameCredentialByTemplateId invokes the domain.SaveTaskForSubmittingDomainNameCredentialByTemplateId API synchronously
func (client *Client) SaveTaskForSubmittingDomainNameCredentialByTemplateId(request *SaveTaskForSubmittingDomainNameCredentialByTemplateIdRequest) (response *SaveTaskForSubmittingDomainNameCredentialByTemplateIdResponse, err error) {
	response = CreateSaveTaskForSubmittingDomainNameCredentialByTemplateIdResponse()
	err = client.DoAction(request, response)
	return
}

// SaveTaskForSubmittingDomainNameCredentialByTemplateIdWithChan invokes the domain.SaveTaskForSubmittingDomainNameCredentialByTemplateId API asynchronously
func (client *Client) SaveTaskForSubmittingDomainNameCredentialByTemplateIdWithChan(request *SaveTaskForSubmittingDomainNameCredentialByTemplateIdRequest) (<-chan *SaveTaskForSubmittingDomainNameCredentialByTemplateIdResponse, <-chan error) {
	responseChan := make(chan *SaveTaskForSubmittingDomainNameCredentialByTemplateIdResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.SaveTaskForSubmittingDomainNameCredentialByTemplateId(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// SaveTaskForSubmittingDomainNameCredentialByTemplateIdWithCallback invokes the domain.SaveTaskForSubmittingDomainNameCredentialByTemplateId API asynchronously
func (client *Client) SaveTaskForSubmittingDomainNameCredentialByTemplateIdWithCallback(request *SaveTaskForSubmittingDomainNameCredentialByTemplateIdRequest, callback func(response *SaveTaskForSubmittingDomainNameCredentialByTemplateIdResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *SaveTaskForSubmittingDomainNameCredentialByTemplateIdResponse
		var err error
		defer close(result)
		response, err = client.SaveTaskForSubmittingDomainNameCredentialByTemplateId(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// SaveTaskForSubmittingDomainNameCredentialByTemplateIdRequest is the request struct for api SaveTaskForSubmittingDomainNameCredentialByTemplateId
type SaveTaskForSubmittingDomainNameCredentialByTemplateIdRequest struct {
	*requests.RpcRequest
	SaleId            string           `position:"Query" name:"SaleId"`
	DomainName        string           `position:"Query" name:"DomainName"`
	UserClientIp      string           `position:"Query" name:"UserClientIp"`
	Lang              string           `position:"Query" name:"Lang"`
	ContactTemplateId requests.Integer `position:"Query" name:"ContactTemplateId"`
}

// SaveTaskForSubmittingDomainNameCredentialByTemplateIdResponse is the response struct for api SaveTaskForSubmittingDomainNameCredentialByTemplateId
type SaveTaskForSubmittingDomainNameCredentialByTemplateIdResponse struct {
	*responses.BaseResponse
	RequestId string `json:"RequestId" xml:"RequestId"`
	TaskNo    string `json:"TaskNo" xml:"TaskNo"`
	Success   bool   `json:"Success" xml:"Success"`
}

// CreateSaveTaskForSubmittingDomainNameCredentialByTemplateIdRequest creates a request to invoke SaveTaskForSubmittingDomainNameCredentialByTemplateId API
func CreateSaveTaskForSubmittingDomainNameCredentialByTemplateIdRequest() (request *SaveTaskForSubmittingDomainNameCredentialByTemplateIdRequest) {
	request = &SaveTaskForSubmittingDomainNameCredentialByTemplateIdRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("Domain", "2016-05-11", "SaveTaskForSubmittingDomainNameCredentialByTemplateId", "domain", "openAPI")
	request.Method = requests.POST
	return
}

// CreateSaveTaskForSubmittingDomainNameCredentialByTemplateIdResponse creates a response to parse from SaveTaskForSubmittingDomainNameCredentialByTemplateId response
func CreateSaveTaskForSubmittingDomainNameCredentialByTemplateIdResponse() (response *SaveTaskForSubmittingDomainNameCredentialByTemplateIdResponse) {
	response = &SaveTaskForSubmittingDomainNameCredentialByTemplateIdResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
