package domain

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// SubmitPurchaseInfo invokes the domain.SubmitPurchaseInfo API synchronously
func (client *Client) SubmitPurchaseInfo(request *SubmitPurchaseInfoRequest) (response *SubmitPurchaseInfoResponse, err error) {
	response = CreateSubmitPurchaseInfoResponse()
	err = client.DoAction(request, response)
	return
}

// SubmitPurchaseInfoWithChan invokes the domain.SubmitPurchaseInfo API asynchronously
func (client *Client) SubmitPurchaseInfoWithChan(request *SubmitPurchaseInfoRequest) (<-chan *SubmitPurchaseInfoResponse, <-chan error) {
	responseChan := make(chan *SubmitPurchaseInfoResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.SubmitPurchaseInfo(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// SubmitPurchaseInfoWithCallback invokes the domain.SubmitPurchaseInfo API asynchronously
func (client *Client) SubmitPurchaseInfoWithCallback(request *SubmitPurchaseInfoRequest, callback func(response *SubmitPurchaseInfoResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *SubmitPurchaseInfoResponse
		var err error
		defer close(result)
		response, err = client.SubmitPurchaseInfo(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// SubmitPurchaseInfoRequest is the request struct for api SubmitPurchaseInfo
type SubmitPurchaseInfoRequest struct {
	*requests.RpcRequest
	PurchaseProofs   *[]string `position:"Body" name:"PurchaseProofs"  type:"Repeated"`
	PurchaseCurrency string    `position:"Body" name:"PurchaseCurrency"`
	BizId            string    `position:"Body" name:"BizId"`
	PurchasePrice    string    `position:"Body" name:"PurchasePrice"`
}

// SubmitPurchaseInfoResponse is the response struct for api SubmitPurchaseInfo
type SubmitPurchaseInfoResponse struct {
	*responses.BaseResponse
}

// CreateSubmitPurchaseInfoRequest creates a request to invoke SubmitPurchaseInfo API
func CreateSubmitPurchaseInfoRequest() (request *SubmitPurchaseInfoRequest) {
	request = &SubmitPurchaseInfoRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("Domain", "2018-02-08", "SubmitPurchaseInfo", "domain", "openAPI")
	request.Method = requests.POST
	return
}

// CreateSubmitPurchaseInfoResponse creates a response to parse from SubmitPurchaseInfo response
func CreateSubmitPurchaseInfoResponse() (response *SubmitPurchaseInfoResponse) {
	response = &SubmitPurchaseInfoResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
