package ehpc

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// DescribeServerlessJobs invokes the ehpc.DescribeServerlessJobs API synchronously
func (client *Client) DescribeServerlessJobs(request *DescribeServerlessJobsRequest) (response *DescribeServerlessJobsResponse, err error) {
	response = CreateDescribeServerlessJobsResponse()
	err = client.DoAction(request, response)
	return
}

// DescribeServerlessJobsWithChan invokes the ehpc.DescribeServerlessJobs API asynchronously
func (client *Client) DescribeServerlessJobsWithChan(request *DescribeServerlessJobsRequest) (<-chan *DescribeServerlessJobsResponse, <-chan error) {
	responseChan := make(chan *DescribeServerlessJobsResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.DescribeServerlessJobs(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// DescribeServerlessJobsWithCallback invokes the ehpc.DescribeServerlessJobs API asynchronously
func (client *Client) DescribeServerlessJobsWithCallback(request *DescribeServerlessJobsRequest, callback func(response *DescribeServerlessJobsResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *DescribeServerlessJobsResponse
		var err error
		defer close(result)
		response, err = client.DescribeServerlessJobs(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// DescribeServerlessJobsRequest is the request struct for api DescribeServerlessJobs
type DescribeServerlessJobsRequest struct {
	*requests.RpcRequest
	ClusterId string    `position:"Query" name:"ClusterId"`
	JobIds    *[]string `position:"Query" name:"JobIds"  type:"Repeated"`
}

// DescribeServerlessJobsResponse is the response struct for api DescribeServerlessJobs
type DescribeServerlessJobsResponse struct {
	*responses.BaseResponse
	TotalCount int       `json:"TotalCount" xml:"TotalCount"`
	RequestId  string    `json:"RequestId" xml:"RequestId"`
	JobInfos   []JobInfo `json:"JobInfos" xml:"JobInfos"`
}

// CreateDescribeServerlessJobsRequest creates a request to invoke DescribeServerlessJobs API
func CreateDescribeServerlessJobsRequest() (request *DescribeServerlessJobsRequest) {
	request = &DescribeServerlessJobsRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("EHPC", "2018-04-12", "DescribeServerlessJobs", "ehs", "openAPI")
	request.Method = requests.POST
	return
}

// CreateDescribeServerlessJobsResponse creates a response to parse from DescribeServerlessJobs response
func CreateDescribeServerlessJobsResponse() (response *DescribeServerlessJobsResponse) {
	response = &DescribeServerlessJobsResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
