package live

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// StopEdgeTranscodeJob invokes the live.StopEdgeTranscodeJob API synchronously
func (client *Client) StopEdgeTranscodeJob(request *StopEdgeTranscodeJobRequest) (response *StopEdgeTranscodeJobResponse, err error) {
	response = CreateStopEdgeTranscodeJobResponse()
	err = client.DoAction(request, response)
	return
}

// StopEdgeTranscodeJobWithChan invokes the live.StopEdgeTranscodeJob API asynchronously
func (client *Client) StopEdgeTranscodeJobWithChan(request *StopEdgeTranscodeJobRequest) (<-chan *StopEdgeTranscodeJobResponse, <-chan error) {
	responseChan := make(chan *StopEdgeTranscodeJobResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.StopEdgeTranscodeJob(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// StopEdgeTranscodeJobWithCallback invokes the live.StopEdgeTranscodeJob API asynchronously
func (client *Client) StopEdgeTranscodeJobWithCallback(request *StopEdgeTranscodeJobRequest, callback func(response *StopEdgeTranscodeJobResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *StopEdgeTranscodeJobResponse
		var err error
		defer close(result)
		response, err = client.StopEdgeTranscodeJob(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// StopEdgeTranscodeJobRequest is the request struct for api StopEdgeTranscodeJob
type StopEdgeTranscodeJobRequest struct {
	*requests.RpcRequest
	JobId     string           `position:"Query" name:"JobId"`
	ClusterId string           `position:"Query" name:"ClusterId"`
	OwnerId   requests.Integer `position:"Query" name:"OwnerId"`
}

// StopEdgeTranscodeJobResponse is the response struct for api StopEdgeTranscodeJob
type StopEdgeTranscodeJobResponse struct {
	*responses.BaseResponse
	JobId     string `json:"JobId" xml:"JobId"`
	RequestId string `json:"RequestId" xml:"RequestId"`
}

// CreateStopEdgeTranscodeJobRequest creates a request to invoke StopEdgeTranscodeJob API
func CreateStopEdgeTranscodeJobRequest() (request *StopEdgeTranscodeJobRequest) {
	request = &StopEdgeTranscodeJobRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("live", "2016-11-01", "StopEdgeTranscodeJob", "live", "openAPI")
	request.Method = requests.POST
	return
}

// CreateStopEdgeTranscodeJobResponse creates a response to parse from StopEdgeTranscodeJob response
func CreateStopEdgeTranscodeJobResponse() (response *StopEdgeTranscodeJobResponse) {
	response = &StopEdgeTranscodeJobResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
