package paifeaturestore

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// ListProjectFeatureViewTags invokes the paifeaturestore.ListProjectFeatureViewTags API synchronously
func (client *Client) ListProjectFeatureViewTags(request *ListProjectFeatureViewTagsRequest) (response *ListProjectFeatureViewTagsResponse, err error) {
	response = CreateListProjectFeatureViewTagsResponse()
	err = client.DoAction(request, response)
	return
}

// ListProjectFeatureViewTagsWithChan invokes the paifeaturestore.ListProjectFeatureViewTags API asynchronously
func (client *Client) ListProjectFeatureViewTagsWithChan(request *ListProjectFeatureViewTagsRequest) (<-chan *ListProjectFeatureViewTagsResponse, <-chan error) {
	responseChan := make(chan *ListProjectFeatureViewTagsResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.ListProjectFeatureViewTags(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// ListProjectFeatureViewTagsWithCallback invokes the paifeaturestore.ListProjectFeatureViewTags API asynchronously
func (client *Client) ListProjectFeatureViewTagsWithCallback(request *ListProjectFeatureViewTagsRequest, callback func(response *ListProjectFeatureViewTagsResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *ListProjectFeatureViewTagsResponse
		var err error
		defer close(result)
		response, err = client.ListProjectFeatureViewTags(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// ListProjectFeatureViewTagsRequest is the request struct for api ListProjectFeatureViewTags
type ListProjectFeatureViewTagsRequest struct {
	*requests.RoaRequest
	InstanceId string `position:"Path" name:"InstanceId"`
	ProjectId  string `position:"Path" name:"ProjectId"`
}

// ListProjectFeatureViewTagsResponse is the response struct for api ListProjectFeatureViewTags
type ListProjectFeatureViewTagsResponse struct {
	*responses.BaseResponse
	RequestId string   `json:"RequestId" xml:"RequestId"`
	Tags      []string `json:"Tags" xml:"Tags"`
}

// CreateListProjectFeatureViewTagsRequest creates a request to invoke ListProjectFeatureViewTags API
func CreateListProjectFeatureViewTagsRequest() (request *ListProjectFeatureViewTagsRequest) {
	request = &ListProjectFeatureViewTagsRequest{
		RoaRequest: &requests.RoaRequest{},
	}
	request.InitWithApiInfo("PaiFeatureStore", "2023-06-21", "ListProjectFeatureViewTags", "/api/v1/instances/[InstanceId]/projects/[ProjectId]/featureviewtags", "", "")
	request.Method = requests.GET
	return
}

// CreateListProjectFeatureViewTagsResponse creates a response to parse from ListProjectFeatureViewTags response
func CreateListProjectFeatureViewTagsResponse() (response *ListProjectFeatureViewTagsResponse) {
	response = &ListProjectFeatureViewTagsResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
